#!/usr/bin/python
# -*- python -*-
#
# A thoroughly lame weblog
# (C) 2002 Chris Lawrence

import cgitb; cgitb.enable()

import sys, cgi, psycopg, re, Cookie, urllib, os, blog_admin, db_row

from blog_config import *
from blog import *

def make_form(formtype):
    header('blog.lordsutch.com: Add '+formtype)

    print '<form action="%s" method="post" enctype="multipart/form-data" accept-charset="utf-8 ascii" accept="text/html,text/plain">' % MODURL
    print '<input type="hidden" name="new%s" value="1">' % formtype

    print '<label>' + formtype.capitalize() + ' Name: '
    print '<input name="%sname" size="60" /></label><br />' % formtype
    if formtype == 'topic':
        print '<label>Description: <input name="topicdesc" size="120" /></label><br />'
        print '<label>Open Directory Schema: <input name="odtopic" size="120" /></label><br />'
    elif formtype == 'author':
        print '<label>Email: <input name="authoremail" size="80" /></label><br />'
        print '<label>URL: <input name="authorurl" size="100"></label><br />'
        print '<label>Login: <input name="login" size="16"></label><br />'
    print '<input type="submit" value="Submit" />'
    print '</form>'
    footer()

def main():
    form = cgi.FieldStorage()
    if form.has_key('newauthor'):
        make_form('author')
        return
    elif form.has_key('newtopic'):
        make_form('topic')
        return

    entryid = form.getfirst('entryid')
    eid = None
    if entryid:
        try:
            eid = int(entryid)
        except:
            pass

    cookie_str = os.environ.get('HTTP_COOKIE', '')
    try:
        cookies = Cookie.BaseCookie(cookie_str)
    except Cookie.CookieError:
        cookies = Cookie.BaseCookie()

    try:
        use_style = cookies['style'].value
    except:
        use_style = blog_config.DEF_STYLESHEET

    if form.has_key('trackback') and eid:
        blog_admin.manage_trackbacks(eid, use_style)
        return

    title = body = ''
    author = 1
    tlist = []
    visible = True
    best = False
    entry = {'visible' : True, 'pinned' : False, 'author' : author,
             'ping' : True, 'wlping' : True}

    db = psycopg.connect(DSN)
    cursor = db.cursor()
    if eid is not None:
        cursor.execute('SELECT title, body, extended, author, visible, pinned,'
                       'excerpt FROM content WHERE content.entryid=%d' % eid)
        if cursor.rowcount:
            R = db_row.MetaRow(cursor.description)
            entry = R(cursor.fetchone())
            cursor.execute('SELECT topic FROM topicmap WHERE entryid=%d' % eid)
            tlist = [x[0] for x in cursor.fetchall()]
        else:
            eid=None

        cursor.execute('SELECT * FROM best WHERE entryid=%d' % eid)
        best = (cursor.rowcount != 0)

    if eid is None:
        header(BLOG_TITLE+': Add entry', use_style=use_style)
    else:
        header(BLOG_TITLE+': Edit entry', use_style=use_style)

    print '<p><a href="%s">[Post Admin]</a>' % ADMINURL
    if eid is not None:
        print '<a href="%s?trackback=1&amp;entryid=%d">[Manage Trackbacks]</a>' % (EDITURL, eid)
    print '<a href="%s">[BlogFront]</a></p>' % URL

    # Use PyTextile if it's globally enabled and this is a new post
    textile = TEXTILE and (eid is None)
    blog_admin.edit_form(entry, db, eid=eid, preview=bool(eid),
                         textile=textile, updatemod=bool(eid),
                         ping=True, wlping=not eid, tlist=tlist, best=False)
    print '<!-- %s -->' % repr(tlist)
    footer()

if __name__ == '__main__':
    main()
