#!/usr/bin/python
# -*- python -*-
#
# A thoroughly lame weblog
# (C) 2002 Chris Lawrence

import cgitb; cgitb.enable()

import sys, cgi, psycopg, re, urllib, os, blog_admin, db_row
import blog_config, Cookie

def main():
    form = cgi.FieldStorage()
    limit = form.getfirst('limit')
    if limit:
        try:
            limit = int(limit)
        except:
            limit = None
    limit = limit or blog_config.DEFLIMIT
    # Make sure limit is in [1, 50]
    limit = min(max(1, limit), 50)

    offset = form.getfirst('offset')
    if offset:
        try:
            offset = int(offset)
        except:
            offset = None

    # Make sure the offset >=0
    offset = max(offset or 0, 0)

    blogroll = form.getfirst('blogroll')
    if blogroll:
        try:
            blogroll = bool(int(blogroll))
        except:
            blogroll = False
    blogroll = blogroll or False

    name = form.getfirst('name')
    url = form.getfirst('url')

    cookie_str = os.environ.get('HTTP_COOKIE', '')
    try:
        cookies = Cookie.BaseCookie(cookie_str)
    except Cookie.CookieError:
        cookies = Cookie.BaseCookie()

    blog_admin.admin_interface(offset=offset, limit=limit, blogroll=blogroll,
                               name=name, url=url, cookies=cookies)

main()
