#!/usr/bin/env python

import os, re
from blog_config import *

force = 1

def tidy(body):
    if not body or not TIDY or not os.path.exists(TIDY): return body

    use_unicode = isinstance(body, unicode)
    oldbody = body
    if use_unicode:
        body = body.encode('UTF-8')

    (stdin, stdout, stderr) = os.popen3('%s --output-encoding ascii --input-encoding utf8 --logical-emphasis t --show-body-only t --wrap 0 --show-warnings 0 -q --drop-empty-paras t --output-xhtml t --force-output %d' % (TIDY, force))
    stdin.write(body)
    stdin.close()
    content = stdout.read()
    errors = stderr.read()
    if not content:
        return oldbody, errors
    #if use_unicode:
    #    content = unicode(content, 'ascii')
    return content, errors

if __name__ == '__main__':
    x, y = tidy(file('/usr/share/doc/tidy/htmldoc/Overview.html').read())
    print x
