# Proxy dictionary object for a cgi.FieldStorage.  This hack makes it possible
# to treat a FieldStorage as a dictionary...
#
# Note that this is an incomplete implementation.  Using UserDict.DictMixin
# to fill this out would be highly recommended in Python 2.3+.
from __future__ import generators

import cgi

class ezFieldStorage(dict):
    def __init__(self, **args):
        fs = cgi.FieldStorage(**args)
        for field in fs.keys():
            self[field] = fs.getvalue(field)

    def getfirst(self, field, default=None):
        x = self.get(field, default)
        if isinstance(x, (list, tuple)):
            return x[0]
        return x

    def getlist(self, field):
        x = self.get(field)
        if x is None:
            return []
        elif isinstance(x, (list, tuple)):
            return x
        return [x]
