#!/usr/bin/python2.2
import psycopg, tidy

DSN='dbname=blog'
db = psycopg.connect(DSN)
cursor = db.cursor()

cursor.execute('BEGIN TRANSACTION')
cursor.execute('SELECT entryid, body FROM content')
for (entryid, body) in cursor.fetchall():
    if body[:2].lower() != '<p>': body = '<p>'+body 
    newbody, err = tidy.tidy(body)
    #if entryid == 56:
    #    print `body`, `newbody`, entryid, err
    cursor.execute('UPDATE content SET newbody=%(newbody)s WHERE entryid=%(entryid)d', locals())
cursor.execute('COMMIT TRANSACTION')
