#!/usr/bin/python

import cgitb; cgitb.enable()

import blog_config
import blog_admin
import os
import Cookie
import cgi

def main():
    cookie_str = os.environ.get('HTTP_COOKIE', '')
    try:
        cookies = Cookie.BaseCookie(cookie_str)
    except Cookie.CookieError:
        cookies = Cookie.BaseCookie()

    form = cgi.FieldStorage()
    if form.has_key('linkto'):
        linkto = form.getfirst('linkto')
        if ' ' in linkto:
            link = linkto.split(' ', 1)
        else:
            link = (linkto, '')
        blog_admin.make_new_post_form(link, cookies=cookies)
        return

    if form.has_key('url'):
        url = form.getfirst('url')

    if not url:
        url = os.environ.get('HTTP_REFERER')
    
    if url and not url.startswith('about:'):
        blog_admin.post_from_url(url)
    else:
        print 'Status: 302'
        print 'Location: '+blog_config.EDITURL
        print

if __name__ == '__main__':
    main()
