URL='http://blog.lordsutch.com/'
HOSTURL='blog.lordsutch.com'
EDITURL='/admin/edit.cgi'   # CGI to generate edit form
MODURL='/admin/mod.cgi'     # CGI to do the modifications
LINKPOSTURL='/admin/link.cgi' # CGI to generate an edit form with links
ADMINURL='/admin/'
RSSURL='/rss/'              # Location of the RSS feed
OPMLURL='/opml/'
TBURL=URL+'tb.cgi'

# Database to connect to; you will want to change this if you host multiple
# blogs on the same system
DSN='dbname=blog'

# Graphics
IMAGEURL="/images/"
BUTTONS="/buttons/"
CSS = '/css/'

LINKURL=IMAGEURL+"permalink.png"
XMLLINKURL=IMAGEURL+"xml.png"

CONFIGURL='/config'
# CONFIGURL='/config.cgi'
COOKIEURL='/setcookie'
# COOKIEURL='/setcookie.cgi'

# Screen stylesheets
STYLESHEETS = {
    'sans' : ('Sans-serif look', CSS+'style.css'),
    'serif' : ('Serif look', CSS+'altstyle.css'),
    'runin' : ('Run-in look (sans-serif)', CSS+'runin.css'),
    'runin-serif' : ('Run-in look (serif)', CSS+'runin-serif.css'),
    'hotty-toddy' : ('University look', CSS+'hotty-toddy.css'),
    'dd2' : ('BlogSpot-ish look (orange/brown)', CSS+'dd2.css'),
    'dd2-red' : ('BlogSpot-ish look (red/blue)', CSS+'dd2-red.css'),
    'offwhite' : ('BlogSpot-ish look (off-white)', CSS+'offwhite.css'),
    'dd2-dirk' : ('BlogSpot-ish look (complimentary)', CSS+'dd2-dirk.css'),
#    'fhs' : ('Green and gold', CSS+'fhs.css'),
    }
#DEF_STYLESHEET = 'dd2-red'
#DEF_STYLESHEET = 'hotty-toddy'
DEF_STYLESHEET = 'dd2-dirk'

# Other media stylesheets
PRINT_STYLESHEET=CSS+"print.css"
HANDHELD_STYLESHEET=CSS+"handheld.css"

# Syndication crap
LANG = 'en'

BLOG_TITLE='Signifying Nothing'
BLOG_DESC="Where Mississippi Meets Memphis Halfway"

BLOG_LONGDESC='''\
Ravings, rants, and more from:
<ul class="plain">

<li><a href="/?author=1" class="author-1" style="font-weight:
bolder">Chris Lawrence</a>, Ph.D., an underemployed libertarian
political scientist at <a href="http://www.olemiss.edu/">the
University of Mississippi</a> in <a
href="http://www.oxfordms.com/">Oxford</a>.

<li><a href="/?author=2" class="author-2" style="font-weight:
bolder">Brock Sides</a>, a left-leaning philosopher turned network
administrator currently residing in <a
href="http://www.ci.memphis.tn.us/">Memphis, Tennessee</a>.

</ul>'''

#<!-- (currently hiding from the authorities at <a
#href="http://www.icpsr.org/">ICPSR</a> in <a
#href="http://www.annarbor.org/">Ann Arbor, Michigan</a>) -->

TTL=20

MAILTO="blog@lordsutch.com"

# Copyright
CYEAR="2002&ndash;03"

# Set to None to use a non-CC license
CCLICENSE = 'http://creativecommons.org/licenses/by-nd/1.0/'

CNOTICE = '''\
<p><!-- Creative Commons License -->
<a href="http://creativecommons.org/licenses/by-nd/1.0/"><img alt="Creative Commons License" border="0" src="%(BUTTONS)scc.png" /></a><br />
The contents of this weblog are licensed under a
<a href="http://creativecommons.org/licenses/by-nd/1.0/">Creative Commons License</a>.
<!-- /Creative Commons License -->

<!--
<rdf:RDF xmlns="http://web.resource.org/cc/"
xmlns:dc="http://purl.org/dc/elements/1.1/"
xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="http://blog.lordsutch.com/">
   <dc:title>Signifying Nothing</dc:title>
   <dc:description>Ravings, rants, and more from a libertarian political scientist wanna&#45;be at the University of Mississippi in Oxford.</dc:description>
   <dc:creator><Agent><dc:title>Chris Lawrence</dc:title></Agent></dc:creator>
   <dc:rights><Agent><dc:title>Chris Lawrence</dc:title></Agent></dc:rights>
   <dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
   <license rdf:resource="http://creativecommons.org/licenses/by-nd/1.0/" />
</Work>

<License rdf:about="http://creativecommons.org/licenses/by-nd/1.0/">
<requires rdf:resource="http://web.resource.org/cc/Attribution" />
<permits rdf:resource="http://web.resource.org/cc/Reproduction" />
<permits rdf:resource="http://web.resource.org/cc/Distribution" />
<requires rdf:resource="http://web.resource.org/cc/Notice" />
</License>

</rdf:RDF>
--></p>''' % globals()

# CNOTICE="All rights reserved."

OWNER="Chris Lawrence and Brock Sides"
#FULL_OWNER='%s &lt;<a href="mailto:%s">%s</a>&gt;' % (OWNER, MAILTO, MAILTO)
FULL_OWNER=OWNER
CONTACT_URI="mailto:blog@lordsutch.com"

#WEBSERVER = '<a href="http://httpd.apache.org/">Apache HTTP Server</a>'
#HOST_OS = '<a href="http://www.debian.org/">Debian GNU/Linux</a>'

WEBSERVER = {'link' : 'http://httpd.apache.org/', 'button' : 'apache.png',
             'text' : 'Apache HTTP Server'}
HOST_OS = {'link' : 'http://www.debian.org/', 'button' : 'debian.png',
           'text' : 'Debian GNU/Linux'}

TOPMATTER='''<a href="/" title="Welcome to Signifying Nothing"><img
src="/local/topbanner.png" width="479" height="48" border="0"
alt="[Signifying Nothing]" title="Welcome to Signifying Nothing" /></a>'''

PLAIN_TOPMATTER='<img alt="[Signifying Nothing]" src="/local/topbanner-small.jpg" width="120" height="12" />'

WELCOMEBLOCK='''\
<p>Welcome to <strong><a href="/">Signifying Nothing</a></strong>.  %(BLOG_LONGDESC)s</p>''' % globals()

LONGWELCOMEBLOCK='''\
<ul class="nav">
<li><strong>Homeland Security Status:</strong><br />
<a href="http://www.geekandproud.net/terror/"><img alt="Terror Alert Level"
title="Terror Alert Level" style="border: 1px #00c solid" src=
"http://www.geekandproud.net/terror/terror.php" /></a></li>
<li><a href="http://amish.blogmosis.com/archives/cat_dead_pool.html" title=
"Amish Tech Support Dead Pool"><img src="/local/deadpoolbanner1.gif" alt=
"Amish Tech Support Dead Pool" width="100" height="30" style="border: none"
/></li>
<li><a title="About one of your humble hosts." href="http://www.lordsutch.com/chris/info.html">About Chris</a></li>
<li><a href="http://philarete.home.mindspring.com/philosophy/">Brock&rsquo;s Philosophy Page</a></li>
<li><a title="The fun and exciting website of your humble host." href="http://www.lordsutch.com/">LordSutch.com</a></li>
<li><a title="The national Interstate 69 clearinghouse." href="http://www.i69info.com/">I69Info.com</a></li>
<li><a title="The obligatory policy." href="http://blog.lordsutch.com/?entryid=533">Blogroll Policy</a></li>

<li><p style="font-weight: bolder">December&rsquo;s recommended reading (<a href="http://blog.lordsutch.com/?entryid=936&entryid=864">read more</a>):</p>
<!--Book 1 -->
<p><iframe marginwidth="0" marginheight="0" width="120" height="240" scrolling="no" frameborder="0" src="http://rcm.amazon.com/e/cm?o=1&amp;l=as1&amp;f=ifr&amp;t=memphiswatch&amp;p=8&amp;asins=0374524777&amp;IS2=1&amp;fc1=000000&amp;lc1=6633ff&amp;bc1=ffffff&amp;bg1=ffffff&amp;IS2=1&amp;lt1=_blank"><MAP NAME="boxmap-p8"><AREA SHAPE="RECT" COORDS="14, 200, 103, 207" HREF="http://rcm.amazon.com/e/cm/privacy-policy.html?o=1" ><AREA COORDS="0,0,10000,10000" HREF="http://www.amazon.com/exec/obidos/redirect-home/memphiswatch" ></map><img src="http://rcm-images.amazon.com/images/G/01/rcm/120x240.gif" width="120" height="240" border="0" usemap="#boxmap-p8" alt="Shop at Amazon.com"></iframe></p>
<!-- Book 2 -->
<p><iframe marginwidth="0" marginheight="0" width="120" height="240" scrolling="no" frameborder="0" src="http://rcm.amazon.com/e/cm?o=1&amp;l=as1&amp;f=ifr&amp;t=memphiswatch&amp;p=8&amp;asins=0375422307&amp;IS2=1&amp;fc1=000000&amp;lc1=6633ff&amp;bc1=ffffff&amp;bg1=ffffff&amp;IS2=1&amp;lt1=_blank"><MAP NAME="boxmap-p8"><AREA SHAPE="RECT" COORDS="14, 200, 103, 207" HREF="http://rcm.amazon.com/e/cm/privacy-policy.html?o=1" ><AREA COORDS="0,0,10000,10000" HREF="http://www.amazon.com/exec/obidos/redirect-home/memphiswatch" ></map><img src="http://rcm-images.amazon.com/images/G/01/rcm/120x240.gif" width="120" height="240" border="0" usemap="#boxmap-p8" alt="Shop at Amazon.com"></iframe></p>
<li>Quotes:<ul class="plain">
<li><em>&ldquo;There&rsquo;s a certain desperation in this
bloke&rsquo;s blog.&rdquo;</em> &mdash; <a
href="http://americandissent.blogspot.com/2003_03_23_americandissent_archive.html#91337408"
>Chris Gruber</a>.</li>
<li><em>&ldquo;Flippant.&rdquo;</em> &mdash; <a href="http://dissectleft.blogspot.com/2003_10_05_dissectleft_archive.html#106564445076712922">John Jay Ray</a>.
</ul>
</ul>'''

CREDITBLOCK = '''\
<!-- Begin Amazon Honor System Paybox -->
<img src="http://s1.amazon.com/exec/varzea/tipbox/A3SDTQAO7JOE5G/TSXV866PO3OIH" usemap="#TSXV866PO3OIH" border="0" alt="Amazon Honor System" />
<map name="TSXV866PO3OIH">
<area coords="13,64,108,117" href="http://s1.amazon.com/exec/varzea/pay/TSXV866PO3OIH" alt="Click Here to Pay" target="_top" />
<area coords="13,133,108,145" href="http://s1.amazon.com/exec/varzea/subst/fx/help/how-we-know.html" alt="Learn More" target="_top" />
</map>
<!-- End Amazon Honor System Paybox -->
<p>Do you have feedback?  Send it to us at <a href="mailto:blog@lordsutch.com">blog@lordsutch.com</a>.  All feedback will be considered for <a href="/?topic=22">publication and/or fisking</a>.  You can also comment on particular posts using the <a href="http://www.movabletype.org/trackback/">TrackBack</a> protocol.</p>
<p>Credits:
<ul class="nav-inline">
<li><a href="http://www.gimp.org/"><img alt="[The GIMP]" title="The GIMP" src="/buttons/gimp.png" width="80"
height="15"></a></li>
<li><a href="http://gtmcknight.com/buttons/index.php"><img alt="[Steal These Buttons!]" title="Steal These Buttons!"
src="/buttons/steal.png" width="80" height="15"></a></li>
</ul></p>
'''
#'''<p><a href="http://www.blogshares.com/blogs.php?blog=http%3A%2F%2Fblog.lordsutch.com%2F&user=2976"><img src="http://www.blogshares.com/images/blogshares.jpg" alt="Listed on BlogShares" border="0" width="117" height="23"/></a></p>'''

# Number of entries to return, by default
DEFLIMIT = 24
# How many entries to return in the RSS feed
# RSSLIMIT = 15
RSSLIMIT = DEFLIMIT

# Number of updates to return in the recently... box
UPDATED = 12

# Include the * for updated entries
SHOWUPDATED = False

# Number of words for excerpts to include
EXCERPT_WORDS = 40

# Show/hide the edit link
SHOW_EDIT_LINK=False

# Format dates
# If True, show a header for each day on pages
SHOW_DAY_HEADERS=True

DAYFMT = "'FMDay, FMDD FMMonth FMYYYY'"

BRIEFDATEFMT = "'FMHH12:MI am TZ'" # 12-hour clock
DATEFMT = "'FMDy, FMDD FMMon FMYYYY, FMHH12:MI am TZ'"

#DATEFMT = "'FMDy, FMDD FMMon FMYYYY, HH24:MI TZ'"     # 24-hour clock
#DATEFMT = "'FMDy, FMDD FMMon FMYYYY, HH24MI TZ'"      # 24-hour mil clock

# Used for date navigation on the sidebar
DATEFMT_STRFTIME = '%e %B'

MONTHFMT = "'FMMonth FMYYYY'"


# Default timezone to use internally - also used for months
TIMEZONE = 'America/Chicago'
#TIMEZONE = 'UTC'

# Geographic location data - see http://www.syndic8.com/help_metadata.php
# Change this if you're not in Oxford, Mississippi!
LOCATION = {
    'country' : 'US', 'state' : 'MS', 'city' : 'Oxford',
    'full_country' : 'United States', 'zip' : 38655,
    'latitude' : 34.400, 'longitude' : -89.562, 'altitude' : 141,
    'tgn.id' : 2057155,
    }

KEYWORDS = 'Mississippi, politics, Python, Debian, Linux, political science'
SYNDIC8URL="http://www.syndic8.com/feedinfo.php?FeedID=20509"
GEOURL="http://www.geourl.org/near/?p=%s" % URL

# ThreadTrack URL: get from Janes' Blogosphere; set to None to disable
#TTURL = "http://feeds.blogmatrix.com/cache/0027/002724.thread.js"
#TRACKURL = '/threadtrack.js'

TTURL = None

# Set to None to disable
TIDY = "/usr/bin/tidy"

# Enable/disable PyTextile in posts by default
TEXTILE = True

# How new a blogroll entry must be to get class "blogroll-new"
#NEWNESS = '2 hours 30 minutes'
NEWNESS = '2 hours 5 minutes'

# How new a blogroll entry must be to show up on the front page
# Set to None to disable
#HIDE_BLOGROLL_ENTRY_AFTER = None
HIDE_BLOGROLL_ENTRY_AFTER = '24 hours'

# Daily permalinks: /?day=20030425#entry-352 instead of /?entryid=352
DAILY_PERMALINKS = False

# Dump a full month as a single page (instead of using older/newer nav)
FULL_MONTH_ARCHIVES = True

# Include trackbacks inline
INLINE_TRACKBACK = True
# Include times in inline trackbacks
INLINE_TRACKBACK_TIMES = False

# Technorati API key - only needed for inline link cosmos - set to None to
# disable this!
#TECHNORATI_API_KEY = None
TECHNORATI_API_KEY = "b60e1993219acab243245a3502565a2f"
COSMOS_LINK = False

#TECHNORATI_PROFILE = None
TECHNORATI_PROFILE = "http://www.technorati.com/profile/lordsutch/38449/5279e1ee559a368a21d479a67190449a"

# Sitemeter ID
#SITEMETER_ID = None
SITEMETER_HOST = 'sm8.sitemeter.com'
SITEMETER_ID = "sm8lordsutch"

# If number of entries on the page < FULL_THRESHOLD, display the full entry
FULL_THRESHOLD = 5

# If true, the entry title will link to the post itself too
LINKTITLE = True
